#include <stdio.h>

#define NCH 18
#define NCHIP 4
#define NDIM 400

#define A16D16 "/dev/vme16d16"
 
 
#define ADDRESS_DSP 0x6000   // <--
#define SIZE_DSP 0x20     // <--

int Cprintf(char *fmt, char*cmd){
//  printf("%s\n",cmd);
  system(cmd);
}


int main(int argc, char **argv){
  FILE *fp;
  int i,j,ch,data;
  int ndim=NDIM;
  char line[NDIM];
  char cmd[200];

  int   flag=0;
  int  offset[72];
  int  threshold[4];
  
  int  ochip[NCHIP]={0x220,0x221,0x224,0x225};
  //            # DAC A1     A2    C1    C2
  int  tchip[NCHIP]={0x90, 0x91,  0x94, 0x95};
  if (argc<2) {
    fprintf(stderr,"Usage:%s <hapd_offset.file>\n",argv[0]);
    fprintf(stderr,"Usage:%s  <commonthreshold> <commonoffset> <flagoffset>\n",argv[0]);
    exit(0);
  }
 
  if (argc<3){
    fp=fopen(argv[1],"r");
    
    while (fgets(line,ndim,fp)!=NULL) {
      if (line[0]=='#') continue;
      if (!sscanf(line,"%s%d%d",cmd,&ch,&data)) continue;
      if (strstr(cmd  ,"O" ) != NULL){
	threshold[ch]=data;
      } else {
	offset[ch]=data;
      }
    }
  } else {
    for  (i=0;i<NCHIP;i++) threshold[i]=atoi(argv[1]);
    for  (i=0;i<NCHIP*NCH;i++) offset[i]=atoi(argv[2]);
    flag=atoi(argv[3]);

  }
  flag=flag  & 0x7;

  //  sprintf(cmd,"./hapd d");          Cprintf("%s\n",cmd);
  sprintf(cmd,"./hapd c 0x30; ./hapd w 18");Cprintf("%s\n",cmd);//  NREP
  for  (i=0;i<NCHIP;i++){
    sprintf(cmd,"./hapd c 0x%X",tchip[i]);          Cprintf("%s\n",cmd);
    sprintf(cmd,"./hapd w 0x%04X",threshold[i]);    Cprintf("%s\n",cmd);
    sprintf(cmd,"./hapd c 0x%X",0x210);             Cprintf("%s\n",cmd);   
    for  (j=0;j<NCH;j=j+2){
      sprintf(cmd,"./hapd w 0x%02X%02X",
	      offset[j  +i*NCH]<<3 | flag ,
	      offset[j+1+i*NCH]<<3 | flag   );
      Cprintf("%s\n",cmd);
    }
    sprintf(cmd,"./hapd c 0x%X",ochip[i]);          Cprintf("%s\n",cmd);
  }

  
  // # init all
  //  sprintf(cmd,"./hapd c 0x100"); Cprintf("%s\n",cmd);
  
  // # veto enable etc. 
  sprintf(cmd,"./hapd c 0x210;./hapd w 0x233;./hapd c 0x240 ");
  Cprintf("%s\n",cmd);

  // # delay = 9; clock cycle = 3
  sprintf(cmd,"./hapd c 0x210;./hapd w 0x903;./hapd c 0x250 ");
  Cprintf("%s\n",cmd);
  
  return 0;
}
